#include <stdio.h>

using namespace std;

int main()
{
    int n, k;
    int a[501000];

    scanf("%d%d", &n, &k);

    for(int i = 0; i < n; i++)
    {
        scanf("%d", &a[i]);

        if(i == 0)
            continue;

        if(k > 0 && a[i - 1] > a[i])
        {
            k--;
            a[i - 1] = -1;

            ///DA LI JE SADA NEKO IZA VECI
            for(int j = i - 2; j >= 0; j--)
            {
                if(a[j] == -1)
                    continue;

                if(k > 0 && a[j] > a[i])
                {
                    k--
                    a[j] = -1;
                }
                else
                    break;
            }
        }
    }

    int i = n - 1;
    while(k > 0)
    {
        if(a[i] != -1)
        {
            obrisani++;
            a[i--] = -1;
        }
        else i--;
    }

    for(int i = 0; i < n; i++)
    {
        if(a[i] != -1)
            printf("%d ", a[i]);
    }

    return 0;
}